<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- qtcreatorcdbextension.cpp -->
  <title>Qt Creator CDB Extensions | Extending Qt Creator Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="extending-index.html">Extending Qt Creator Manual</a></td><td >Qt Creator CDB Extensions</td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right"><a href="extending-index.html">Extending Qt Creator Manual 4.11.1</a></td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
<div class="sidebar"><div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">Qt Creator CDB Extensions</h1>
<span class="subtitle"></span>
<!-- $$$qtcreatorcdbext-description -->
<div class="descr"> <a name="details"></a>
<p>Qt Creator CDB extensions are loaded into CDB.exe (see cdbengine.cpp). They provide the following features:</p>
<ul>
<li>Notification about the state of the debugging session:<ul>
<li>idle: (hooked with .idle_cmd) debuggee stopped</li>
<li>accessible: Debuggee stopped, cdb.exe accepts commands</li>
<li>inaccessible: Debuggee runs, no way to post commands</li>
<li>session active/inactive: Lost debuggee, terminating.</li>
</ul>
</li>
<li>Hook up with output/event callbacks and produce formatted output</li>
<li>Provide some extension commands that produce output in a standardized (GDBMI) format that ends up in handleExtensionMessage().</li>
</ul>
</div>
<!-- @@@qtcreatorcdbext -->
<div class="table"><table class="annotated">
<tr class="odd topAlign"><td class="tblName"><p><a href="">containerChildren()</a></p></td></tr>
<tr class="even topAlign"><td class="tblName"><p><a href="">containerSize()</a></p></td></tr>
<tr class="odd topAlign"><td class="tblName"><p><a href="abstractsymbolgroupnode.html">AbstractSymbolGroupNode</a></p></td><td class="tblDescr"><p>Abstract base class for a node of SymbolGroup providing the child list interface</p></td></tr>
<tr class="even topAlign"><td class="tblName"><p><a href="basesymbolgroupnode.html">BaseSymbolGroupNode</a></p></td><td class="tblDescr"><p>The base class for a node of SymbolGroup with a flat list of children</p></td></tr>
<tr class="odd topAlign"><td class="tblName"><p><a href="debugfiltersymbolgroupnodevisitor.html">DebugFilterSymbolGroupNodeVisitor</a></p></td><td class="tblDescr"><p>Debug filtering output visitor</p></td></tr>
<tr class="even topAlign"><td class="tblName"><p><a href="debugsymbolgroupnodevisitor.html">DebugSymbolGroupNodeVisitor</a></p></td><td class="tblDescr"><p>Debug output visitor</p></td></tr>
<tr class="odd topAlign"><td class="tblName"><p><a href="dumpparameters.html">DumpParameters</a></p></td><td class="tblDescr"><p>Contains all parameters for GDBMI dumping of a symbol group in one class. The debugging engine passes maps of type names/inames to special integer values indicating hex/dec, etc</p></td></tr>
<tr class="even topAlign"><td class="tblName"><p><a href="dumpsymbolgroupnodevisitor.html">DumpSymbolGroupNodeVisitor</a></p></td><td class="tblDescr"><p>GDBMI dump output visitor used to report locals values back to the debugging engine</p></td></tr>
<tr class="odd topAlign"><td class="tblName"><p><a href="eventcallback.html">EventCallback</a></p></td></tr>
<tr class="even topAlign"><td class="tblName"><p><a href="extensioncommandcontext.html">ExtensionCommandContext</a></p></td></tr>
<tr class="odd topAlign"><td class="tblName"><p><a href="extensioncontext.html">ExtensionContext</a></p></td></tr>
<tr class="even topAlign"><td class="tblName"><p><a href="localssymbolgroup.html">LocalsSymbolGroup</a></p></td><td class="tblDescr"><p>Creates a Symbol group representing the Locals view</p></td></tr>
<tr class="odd topAlign"><td class="tblName"><p><a href="mapnodesymbolgroupnode.html">MapNodeSymbolGroupNode</a></p></td><td class="tblDescr"><p>[fake] map node with a fake array index and key/value entries consisting of ReferenceSymbolGroupNode</p></td></tr>
<tr class="even topAlign"><td class="tblName"><p><a href="parameters.html">Parameters</a></p></td></tr>
<tr class="odd topAlign"><td class="tblName"><p><a href="qtinfo.html">QtInfo</a></p></td><td class="tblDescr"><p>Qt information determined on demand</p></td></tr>
<tr class="even topAlign"><td class="tblName"><p><a href="referencesymbolgroupnode.html">ReferenceSymbolGroupNode</a></p></td><td class="tblDescr"><p>Artificial node referencing another (real) SymbolGroupNode (added symbol or symbol from within an expanded linked list structure)</p></td></tr>
<tr class="odd topAlign"><td class="tblName"><p><a href="symbolgroup.html">SymbolGroup</a></p></td><td class="tblDescr"><p>Creates a symbol group storing a tree of expanded symbols rooted on a fake &quot;locals&quot; root element</p></td></tr>
<tr class="even topAlign"><td class="tblName"><p><a href="symbolgroupnode.html">SymbolGroupNode</a></p></td><td class="tblDescr"><p>Represents a real node within a symbol group, identified by its index in IDebugSymbolGroup</p></td></tr>
<tr class="odd topAlign"><td class="tblName"><p><a href="symbolgroupnodevisitor.html">SymbolGroupNodeVisitor</a></p></td><td class="tblDescr"><p>Visitor that iterates over the nodes and builds the full iname path ('local.foo.bar') that is required for GDBMI dumping</p></td></tr>
<tr class="even topAlign"><td class="tblName"><p><a href="symbolgroupvalue.html">SymbolGroupValue</a></p></td><td class="tblDescr"><p>Flyweight tied to a SymbolGroupNode providing a convenient operator[] (name, index) and value getters for notation of dumpers</p></td></tr>
<tr class="odd topAlign"><td class="tblName"><p><a href="symbolgroupvaluecontext.html">SymbolGroupValueContext</a></p></td><td class="tblDescr"><p>Passes all IDebug interfaces required for SymbolGroupValue</p></td></tr>
<tr class="even topAlign"><td class="tblName"><p><a href="watchessymbolgroup.html">WatchesSymbolGroup</a></p></td><td class="tblDescr"><p>Creates a watch symbol group</p></td></tr>
</table></div>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
